#include "newCalcFundamental.h"

using namespace std ;

/**
 * @file calc3DPosition.cc
 * @briedf 3֤
 * @param x1 x2 ħο
 * @param f1 f2 ƥξΥ
 * @param t ¿ʥѥ᡼
 * @param R ž
 * @param X 3֤Ǽ٥ȥ
 * @author Kento YAMADA
 * @date 2008.11.22
 */

void calc3DPosition( vector< VecC > &x1, vector< VecC > &x2,
                     const double f1, const double f2,
                     VecC &t, const Mat R, vector< VecC > &X ) {

  Mat tmpMat( 3, 4 ) ;  //!< ( I 0)  ( ~R -~R*t) Ū˳Ǽ
  Mat P1( 3 , 4 ),  P2( 3, 4 ) ;  //!< \mP  \mP^\prime Ǽ
  Mat A( 4, 3 ) ;  //!< ϢΩ1 \mA Ǽ
  VecC b( 4 ) ;  //!< ϢΩ1 \vb Ǽ٥ȥ

  /* STEP 01 */
  /* 3x4 \mP \mP^\prime ׻ */
  tmpMat[0][0] = 1;  tmpMat[0][1] = 0;  tmpMat[0][2] = 0;  tmpMat[0][3] = 0 ;
  tmpMat[1][0] = 0;  tmpMat[1][1] = 1;  tmpMat[1][2] = 0;  tmpMat[1][3] = 0 ;
  tmpMat[2][0] = 0;  tmpMat[2][1] = 0;  tmpMat[2][2] = 1;  tmpMat[2][3] = 0 ;
  P1 = diag33( 1.0, 1.0, f/f1 ) * tmpMat ;

  for( int i = 0; i < 3; i++ ) {
    for( int j = 0; j < 3; j++ ) {
      tmpMat[i][j] = (~R)[i][j] ;
    }
    tmpMat[i][3] = -((~R)*t)[i] ;
  }
  P2 = diag33( 1.0, 1.0, f/f2 ) * tmpMat ;


  /* STEP 02 */
  /* 3֤ */
  for( unsigned int i = 0; i < x1.size(); i++ ) {
    A[0][0] = x1[i][0]*P1[2][0]-f*P1[0][0]; 
    A[0][1] = x1[i][0]*P1[2][1]-f*P1[0][1]; 
    A[0][2] = x1[i][0]*P1[2][2]-f*P1[0][2]; 
    
    A[1][0] = x1[i][1]*P1[2][0]-f*P1[1][0]; 
    A[1][1] = x1[i][1]*P1[2][1]-f*P1[1][1]; 
    A[1][2] = x1[i][1]*P1[2][2]-f*P1[1][2]; 
    
    A[2][0] = x2[i][0]*P2[2][0]-f*P2[0][0]; 
    A[2][1] = x2[i][0]*P2[2][1]-f*P2[0][1]; 
    A[2][2] = x2[i][0]*P2[2][2]-f*P2[0][2]; 
    
    A[3][0] = x2[i][1]*P2[2][0]-f*P2[1][0]; 
    A[3][1] = x2[i][1]*P2[2][1]-f*P2[1][1]; 
    A[3][2] = x2[i][1]*P2[2][2]-f*P2[1][2];
    
    b[0] = -( x1[i][0]*P1[2][3]-f*P1[0][3] ) ;
    b[1] = -( x1[i][1]*P1[2][3]-f*P1[1][3] ) ;
    b[2] = -( x2[i][0]*P2[2][3]-f*P2[0][3] ) ;
    b[3] = -( x2[i][1]*P2[2][3]-f*P2[1][3] ) ;

    X[i] = inverse(~A*A) * ~A * b ;
  }


  /* STEP 03 */
  /* Z_{\alpha} 顤\mX ȿž */
  double sum = 0.0 ;
  for( unsigned int i = 0; i < X.size(); i++ ) {
    if( X[i][2] > 0 ) {
      sum++ ;
    } else if( X[i][2] < 0 ) {
      sum-- ;
    }
  }

  if( sum < 0 ) {
    cout << "# MIRROR ANSWER" << endl ; 
    t = -t ;
    for( unsigned int i = 0; i < X.size(); i++ ) {
      X[i] = -X[i] ;
    }
  }

}
