#include "newCalcFundamental.h"


/**
 * @file calcV0.cc
 * @brief 9x9\mV_0 ׻
 * @param x1,x2, ׻Ѥб
 * @return V0 9x9оι \mV_0
 * @author Kento YAMADA
 * @date 2009.12.23
 */
Mat calcV0( const VecC x1, const VecC x2 ) {

  Mat V0( 9, 9 ) ;  //!< 9x9оι \mV_0

  /* 9x9оι \mV_0 ׻ */
  V0.clear( 0.0 ) ;
  V0[0][0] = ( x1[0] * x1[0] ) + ( x2[0] * x2[0] ) ;
  V0[1][1] = ( x1[0] * x1[0] ) + ( x2[1] * x2[1] ) ;
  V0[2][2] = V0[5][5] = V0[6][6] = V0[7][7] = f * f ;
  V0[3][3] = ( x1[1] * x1[1] ) + ( x2[0] * x2[0] ) ;
  V0[4][4] = ( x1[1] * x1[1] ) + ( x2[1] * x2[1] ) ;
  V0[0][1] = V0[1][0] = V0[3][4] = V0[4][3] = ( x2[0] * x2[1] ) ;
  V0[0][2] = V0[2][0] = V0[3][5] = V0[5][3] = f * x2[0] ;
  V0[0][3] = V0[3][0] = V0[1][4] = V0[4][1] = x1[0] * x1[1] ;
  V0[0][6] = V0[6][0] = V0[1][7] = V0[7][1] = f * x1[0] ;
  V0[1][2] = V0[2][1] = V0[4][5] = V0[5][4] = f * x2[1] ;
  V0[3][6] = V0[6][3] = V0[4][7] = V0[7][4] = f * x1[1] ;

  return V0 ;
}
