#include "newCalcFundamental.h"
#include <float.h>  // DBL_MAXѤ뤿˥󥯥롼

using namespace std ;

/**
 * @file calcFundamental.cc
 * @brief ħȤ
 * @param x1 x2 бȤǼ٥
 * @param u ñ̥٥ȥ u
 * @param epsilon «ȽѤο
 * @return ǽŪʺƸ
 * @author Kento YAMADA
 * @date 2008.11.17
 */
Mat correctCorrespondingPoints( vector< VecC > &x1, vector< VecC > &x2,
                                VecC u, const double epsilon, double &E,
                                const int update ) {

  unsigned int N = x1.size() ;  //!< ħο \alpha

  /* бȤΥ٥Υγǧ */
  if( x1.size() != x2.size() ) {
    return id_matrix( 3 ) ;
  }

  VecC u_0( 9 ) ;  //!< 9ñ̥٥ȥ \vu_0
  vector< VecC > x1_hat( N ), x2_hat( N ) ;
  vector< VecC > x1_tilde( N ), x2_tilde( N ) ;
  vector< VecC > xi( N ) ;  //!< 9٥ȥ \xi_{\alpha}
  vector< Mat > V_0( N ) ;  //!< 9x9 V_0[\xi_{\alpha}]

  Mat tmpU1( 2, 3 ), tmpU2( 2, 3 ) ;   //!< STEP 06Ѥ׻ѹ
  VecC tmpV1( 3 ), tmpV2( 3 ) ;   //!< STEP 06Ѥ׻ѥ٥ȥ
  Mat F( 3, 3 ) ;  //!< ùǼ
  double err ;  //!< «ȽѤθ
  double E0 = 1e+10 ;  //!< Ƹμ«ȽѤ(ͤϽʬ礭)

  /* STEP 01 */
  /* Ƽѥ᡼ν */
  u_0.clear( 0.0 ) ;
  initParam( x1, x2, x1_hat, x2_hat, x1_tilde, x2_tilde ) ;

  do {
    /* STEP 02 */
    /* 9٥ȥ \xi_{\alpha}  9x9 V_0[\xi_{\alpha}]  */
    for( unsigned int i = 0; i < N; i++ ) {
      xi[i].realloc( 9 ) ;
      xi[i] = calcXi( x1_hat[i], x2_hat[i], x1_tilde[i], x2_tilde[i] ) ;
   
      V_0[i].realloc( 9, 9 ) ;
      V_0[i] = calcV0( x1_hat[i], x2_hat[i] ) ;
    }
   
   
    /* STEP 03 */
    /* ֥ץ EFNS Ƥӡ\vu 򹹿 */
    /* u 򹹿 */
    if( update == UPDATE ) {
      u = EFNS( u, xi, V_0, 1e-6 ) ;
    }

    /* STEP 05 */
    /* \tilde{x_\alpha} \tilde{y_\alpha}
     * \tilde{x_\alpha}^\prime tilde{y_\alpha}^\prime ͤ򹹿*/
    updateParam( x1, x2, x1_hat, x2_hat, x1_tilde, x2_tilde, xi, V_0, u ) ;


    /* STEP 06 */
    /* Ƹ E ׻ */
    E = calcReProjectionErr( x1_tilde, x2_tilde ) ;


    /* STEP 06 */
    /* \vu_0, \hat{x_\alpha}, \hat{x_\alpha},
     * \tilde{x_\alpha}^\prime, \tilde{x_\alpha}^\prime ͤ򹹿*/
    for( unsigned int i = 0; i < N; i++ ) {
      x1_hat[i] = x1[i] - x1_tilde[i] ;
      x2_hat[i] = x2[i] - x2_tilde[i] ;
    }

    cout << "# ReprojectionError : " << E << endl ;
    err = fabs( E - E0 ) ;
    E0 = E ;

    /* ùι */
    u_0 = u ;

  } while( err >= epsilon) ;


  for( unsigned int i = 0; i < x1.size(); i++ ) {
    x1[i] = x1_hat[i] ;
    x2[i] = x2_hat[i] ;
  }


  /* step 07 */
  /* ù */
  F = normalize( setFundamental( u ) ) ;


  return F ;
}
