#include "newCalcFundamental.h"

using namespace std ;

/**
 * @file hartley.cc
 * @brief 8르ꥺѤƴù׻
 * @param x1 x2 бȤǼ٥
 * @return u 9ñ̥٥ȥ
 * @author Kento YAMADA
 * @date 2009.1.8
 */
VecC hartley( const vector< VecC > x1, const vector< VecC > x2 ) {

  unsigned int featNum = 0 ;  //!< ħο \alpha
  VecC u(9) ;
  Mat F( 3, 3 ) ;
  double r, s ;  //!< 8르ꥺѤ礭2Ĥθͭ
  double denominator ;  //!< r,s 뤿ʬ

  /* бȤΥ٥Υγǧ */
  if( x1.size() == x2.size() ) {
    /* ʤФħοȤ */
    featNum = x1.size() ;
  } else {
    VecC err( 9 ) ;
    err.clear(1.0) ;
    return err ;
  }

  //!< бȤ9٥ȥ \xi_{\alpha}
  vector< VecC > xi(featNum) ;
  Mat matrixMLS( 9, 9 ) ;  //!< 9x9 M_{LS}


  /* STEP 01 */
  /* xi_{alpha}  */
  for( unsigned int i = 0; i < featNum; i++ ) {
    xi[i].realloc( 9 ) ;
    xi[i][0] = x1[i][0] * x2[i][0] ;
    xi[i][1] = x1[i][0] * x2[i][1] ;
    xi[i][2] = f * x1[i][0] ;
    xi[i][3] = x1[i][1] * x2[i][0] ;
    xi[i][4] = x1[i][1] * x2[i][1] ;
    xi[i][5] = f * x1[i][1] ;
    xi[i][6] = f * x2[i][0] ;
    xi[i][7] = f * x2[i][1] ;
    xi[i][8] = f * f ;
  }


  /* STEP 02 */
  /* M_{LS}  */
  matrixMLS.clear( 0.0 ) ;  // 
  for( unsigned int i = 0; i < featNum; i++ ) {
    matrixMLS += ( xi[i] * ~xi[i] ) ;
  }


  /* STEP 03 */
  /* M_{LS} ͭʬ򤷡ǾͭͤФ9ñ̸ͭ٥ȥ u ׻ */
  Mat V(9,9), U(9,9) ;
  VecC S(9) ;
  SVD( matrixMLS, V, S, U ) ;
  u = V(8) ;

  /* 줿 u ù F  */
  F = setFundamental( u ) ;


  /* STEP 04 */
  /* ù F ðʬ򤹤 */
  V.realloc( 3, 3 ) ;
  U.realloc( 3, 3 ) ;
  S.realloc( 3 ) ;
  SVD( F, V, S, U ) ;


  /* STEP 05 */
  /* ùοͤ׻ */
  r = S[0] ;
  s = S[1] ;

  /* r  s  */
  denominator = sqrt(r*r + s*s) ;
  r = r / denominator ;
  s = s / denominator ;
  F = V * diag33( r, s, 0.0 ) * ~U ;

  u[0] = F[0][0] ;  u[1] = F[0][1] ;  u[2] = F[0][2] ;
  u[3] = F[1][0] ;  u[4] = F[1][1] ;  u[5] = F[1][2] ;
  u[6] = F[2][0] ;  u[7] = F[2][1] ;  u[8] = F[2][2] ;

  return u ;
}
