#include "newCalcFundamental.h"

using namespace std ;

/**
 * @file initTaubin.cc
 * @brief TaubinˡѤƴù׻ΤνԤ
 * @param x1 x2 бȤǼ٥
 * @return u 9ñ̥٥ȥ
 * @author Kento YAMADA
 * @date 2008.10.31
 */
VecC initTaubin( const vector< VecC > x1, const vector< VecC > x2 ) {

  unsigned int featNum = 0 ;  //!< ħο \alpha
  VecC u( 9 ) ;


  /* бȤΥ٥Υγǧ */
  if( x1.size() == x2.size() ) {
    /* ʤФħοȤ */
    featNum = x1.size() ; } else {
    VecC err( 9 ) ;
    err.clear(1.0) ;
    return err ;
  }

  vector< VecC > z(featNum) ;  //!< 8٥ȥ z_{\alpha}
  vector< Mat > v_0(featNum) ;  //!< 8x8 V_0[z_{\apha}]
  VecC z_bar( 8 ) ;                //!<8٥ȥ롤\bar{z]
  //!<8٥ȥ \tilde{z}_\alpha
  vector< VecC > z_tilde(featNum) ;
  Mat MTB( 8, 8 ), LTB( 8, 8 ) ;   //!<8x8 M_{TB}L_{TB}
  Mat V( 8, 8 ), U( 8, 8 ) ;  //!<ͭʬѤι
  VecC S( 8 ) ;  //!<ͭʬѤΥ٥ȥ
  Mat T( 8, 8 ) ;  //!≮ͭѤ
  VecC v( 8 ) ;  //!<̺ǾͭκǾ̸ͭͤФ̸ͭ٥ȥ


  /* STEP 01 */
  /* z_{alpha}  */
  for( unsigned int i = 0; i < featNum; i++ ) {
    z[i].realloc( 8 ) ;
    z[i][0] = x1[i][0] * x2[i][0] ;
    z[i][1] = x1[i][0] * x2[i][1] ;
    z[i][2] = f * x1[i][0] ;
    z[i][3] = x1[i][1] * x2[i][0] ;
    z[i][4] = x1[i][1] * x2[i][1] ;
    z[i][5] = f * x1[i][1] ;
    z[i][6] = f * x2[i][0] ;
    z[i][7] = f * x2[i][1] ;
  }


  /* STEP 02 */
  /* v_0[z_{alphae}]  */
  for( unsigned int i = 0; i < featNum; i++ ) {
    v_0[i].realloc( 8, 8 ) ;
    v_0[i].clear( 0.0 ) ;
    v_0[i][0][0] = (x1[i][0] * x1[i][0]) + (x2[i][0] * x2[i][0]) ;
    v_0[i][1][1] = (x1[i][0] * x1[i][0]) + (x2[i][1] * x2[i][1]) ;
    v_0[i][2][2] = v_0[i][5][5] = v_0[i][6][6] = v_0[i][7][7] = f * f ;
    v_0[i][3][3] = (x1[i][1] * x1[i][1]) + (x2[i][0] * x2[i][0]) ;
    v_0[i][4][4] = (x1[i][1] * x1[i][1]) + (x2[i][1] * x2[i][1]) ;

    v_0[i][0][1] = v_0[i][1][0] = v_0[i][3][4] = v_0[i][4][3] = x2[i][0] * x2[i][1] ;
    v_0[i][0][2] = v_0[i][2][0] = v_0[i][3][5] = v_0[i][5][3] = f * x2[i][0] ;
    v_0[i][0][3] = v_0[i][3][0] = v_0[i][1][4] = v_0[i][4][1] = x1[i][0] * x1[i][1] ;
    v_0[i][0][6] = v_0[i][6][0] = v_0[i][1][7] = v_0[i][7][1] = f * x1[i][0] ;
    v_0[i][1][2] = v_0[i][2][1] = v_0[i][4][5] = v_0[i][5][4] = f * x2[i][1] ;
    v_0[i][3][6] = v_0[i][6][3] = v_0[i][4][7] = v_0[i][7][4] = f * x1[i][1] ;
  }


  /* STEP 03 */  
  /* \bar{z] */
  z_bar.clear( 0.0 ) ;
  for( unsigned int i = 0; i < featNum; i++ ) {
    z_bar += z[i] ;
  }
  z_bar /= (double)featNum ;

  /* \tilde{z} */
  for( unsigned int i = 0; i < featNum; i++ ) {
    z_tilde[i].realloc( 8 ) ;
    z_tilde[i].clear( 0.0 ) ;
    z_tilde[i] = z[i] - z_bar ;
  }


  /* STEP 04 */
  /* M_{TB}L_{TB} */
  MTB.clear( 0.0 ) ;
  LTB.clear( 0.0 ) ;
  for( unsigned int i = 0; i < featNum; i++ ) {
    MTB += z_tilde[i] * ~z_tilde[i] ;
    LTB += v_0[i] ;
  }


  /* STEP 05 */
  /* ̸ͭ٥ȥ v  */

  /* L_{TB} ͭʬ */
  SVD( LTB, V, S, U ) ;

  /* STEP 05 - (a) */
  /* T = \frac{g_1g_1^T}{\sqrt{\mu_1}} + ... η׻*/
  T.clear( 0.0 ) ;
  for( int i = 0; i < 8; i++ ) {
    T += ( V(i)*~V(i) / sqrt(S[i]) ) ;
  }

  /* STEP 05 - (b) */
  /* TM_{TB}T ͭʬ */
  SVD( T*MTB*T, V, S, U ) ;


  /* STEP 05 - (c) */
  /* ̸ͭ٥ȥ v ׻ */
  v = normalize( T * V( 7 ) ) ;


  /* STEP 06 */
  /* 9ñ̥٥ȥ u  */
  for( int i = 0; i < 8; i++ ) {
    u[i] = v[i] ;
  }
  u[8] = (-( v, z_bar )) / (f * f) ;

  /* u return */
  return normalize( u ) ;
}
