#include <iomanip>
#include <iostream>
#include <fstream>
#include "newCalcFundamental.h"
#include "cmdline.h"

using namespace std ;


double EPS = 1e-15 ;      //!< vec mat 
double DET_EPS = 1e-15 ;  //!< vec mat 


int main( int argc, char *argv[] ) {
  vector< VecC > input1, input2 ;  //!< ϥǡǼ٥
  VecC u(9) ;      //!< 9ñ̥٥ȥ
  double f1, f2 ;  //!< Υ
  double ReProjectionErr ;  //!< ΥˡξκƸ
  VecC t( 3 ) ;    //!< 쥫餫鸫󥫥ؤ¿
  Mat R( 3, 3 ) ;  //!< 쥫餫鸫󥫥ؤβž
  Mat F( 3, 3 ) ;  //!< ù
  string initFlag ;    //!< ùνͤη׻ˡꤹե饰
  gengetopt_args_info args_info ;  //!< ץѤι¤

  if( cmdline_parser(argc, argv, &args_info) != 0 ) {
    return -1 ;
  }


  /**********************************/
  /* бȤΥǡ٥˳Ǽ */
  /**********************************/
  if( ! args_info.input_file2_given ) {
    read( args_info.input_file_arg, input1, input2 ) ;
  } else {
    read( args_info.input_file_arg, input1 ) ;
    read( args_info.input_file2_arg, input2 ) ;
  }



  /****************************/
  /* ϥǡ¸ */
  /****************************/
  vector< VecC > input1_back( input1 ) ;  //!< ϥǡ
  vector< VecC > input2_back( input2 ) ;  //!< ϥǡ



  /********************************************************/
  /* ùνͤη׻ˡ(ǥեȤTaubinˡ) */
  /********************************************************/
  initFlag = args_info.initialize_method_arg ;



  /*********************************************************/
  /* LSM(Ǿˡ)  TaubinˡǴùνͤ */
  /*********************************************************/
  if( initFlag == string("LSM") ) {
    u = initLSM( input1, input2 ) ;  // Ǿˡǽ
  } else if( initFlag == string("Taubin") ) {
    u = initTaubin( input1, input2 ) ;  // Taubinˡǽ
  } else if( initFlag == string("Hartley") ) {
    u = hartley( input1, input2 ) ;
  } else {
    std::cerr << "ùνͤˡϤƤ" << std::endl ;
    return -1 ;
  }



  /****************************/
  /* ϤΥեޥåȤ */
  /****************************/
  //cout << setprecision(5) << setiosflags(ios::scientific) ;



  /**********************/
  /* ξΥ */
  /**********************/
  cout << "# Default Focus : " << f << endl ;



  /******************************************************************/
  /* ͷ׻ǵ᤿ù󤫤顤ùħȤ */
  /******************************************************************/
  if( initFlag == string("Hartley") ) {
    F = setFundamental( u ) ;
  } else {
    F = correctCorrespondingPoints( input1, input2, u, 1e-4, ReProjectionErr, UPDATE ) ;
  }



  /**************************************/
  /* ŬܤùϤ */
  /**************************************/
  if( args_info.fundamental_output_given ) {
    ofstream ofs ;
    ofs.open( args_info.fundamental_output_arg ) ;
    //ofs << setprecision(17) << setiosflags(ios::scientific) ;
    ofs << "# calc F : " << F << endl ;
    ofs << "# |F| : " << det(F) << endl ;
    ofs.close() ;
  } else {
    cout << "# calc F" << F << endl ;
    cout << "# |F| : " << det(F) << endl ;
  }



  /************************/
  /* Υη׻Ԥ */
  /************************/
  int fix    = args_info.fix_flag ;      //!< ΥǷ׻ե饰
  int notfix = args_info.not_fix_flag ;  //!< ŤռͳΥǷ׻ե饰
  int notfixavg = args_info.not_fix_avg_flag ;  //!< ͳΥʿѤǷ׻ե饰

  calcK( F ) ;


  /****************************************/
  /* Υη׻ˡ򡤼ưˤ */
  /****************************************/
  cout << endl << endl ;
  cout << "# calculate Focus" << endl ;
  if( (fix && notfix) || (!fix && !notfix) && !notfixavg ) {
    cout << "# ŤռͳΥˡǷ׻" << endl ;
    calcNotFixFocus( F, f1, f2 ) ;
  } else if( fix && !notfix ) {
    cout << "# ΥˡǷ׻" << endl ;
    calcFixFocus( F, f1, f2 ) ;
  } else if( !fix && notfix ) {
    cout << "# ŤռͳΥˡǷ׻" << endl ;
    calcNotFixFocus( F, f1, f2 ) ;
  } else if( notfixavg ) {
    cout << "# ͳΥʿѤˡǷ׻" << endl ;
    calcNotFixFocusAvg( F, f1, f2 ) ;
  }
  
  if( f1 == f ) {
    cout << "# Υη׻˼Ԥޤ" << endl ;
    return -1 ;
  }


  /******************************/
  /* ¿ʤȲž */
  /******************************/
  calcMotion( input1, input2, F, f1, f2, t, R ) ;


  /********************************************************/
  /* ᤿ Υ ¿ ž 顤ùƷ׻ */
  /********************************************************/
  F = normalize( diag33(1,1,f1/f) * (t % R) * diag33(1,1,f2/f) ) ;


  /**********************************************************/
  /* Ʒ׻ùȡϥǡꡤƸ׻ */
  /**********************************************************/
  F = correctCorrespondingPoints( input1_back, input2_back, setFundamental(F), 1e-4, ReProjectionErr ) ;
  cout << setprecision(3) ;
  cout << endl << endl ;
  cout << "# final ReProjection Error : " << ReProjectionErr << endl ;



  /**************************************************/
  /* ѥ᡼¿ʡžΥˤ */
  /**************************************************/
  if( args_info.camera_param_output_given ) {
    ofstream ofs ;
    ofs.open( args_info.camera_param_output_arg ) ;
    ofs << setprecision(2) << setiosflags(ios::fixed) ;
    ofs << "# Camera Parameters" << endl ; 
    ofs << "# f1  : " << f1 << endl ;
    ofs << "# f2  : " << f2 << endl << endl ;
    ofs << "# R   : " << R  << endl ;
    ofs << "# |R| : " << det(R)  << endl ;
    ofs << "# t   : " << t  << endl ;
    VecC y( 0, 0.5, 0 ), z( 0, 0, 10 ) ;
    
    ofs << "# camera 1" << endl; 
    ofs << "color" << endl ;
    ofs << "1 0 0" << endl ;
    ofs << "line" << endl ;
    ofs << "2" << endl ;
    ofs << "0 0 0" << endl ;
    ofs << y[0] << " " << y[1] << " " << y[2] << endl ;
    ofs << "0 0 0" << endl ;
    ofs << z[0] << " " << z[1] << " " << z[2] << endl ;
    
    y = t + R * y ;
    z = t + R * z ;
    ofs << "# camera 2" << endl; 
    ofs << "color" << endl ;
    ofs << "0 1 0" << endl ;
    ofs << "line" << endl ;
    ofs << "2" << endl ;
    ofs << t[0] << " " << t[1] << " " << t[2] << endl ;
    ofs << y[0] << " " << y[1] << " " << y[2] << endl ;
    ofs << t[0] << " " << t[1] << " " << t[2] << endl ;
    ofs << z[0] << " " << z[1] << " " << z[2] << endl ;
    ofs.close() ;
  } else {
    cout << "# Camera Parameters" << endl ; 
    cout << "# f1 : " << f1 << endl ;
    cout << "# f2 : " << f2 << endl ;
    cout << "# R  : " << R  << endl ;
    cout << "# t  : " << t  << endl ;
  }



  /****************************/
  /* ħ3֤*/
  /****************************/
  vector< VecC > X( input1.size() ) ;
  //calc3DPosition( input1_back, input2_back, f1, f2, t, R, X ) ;
  calc3DPosition( input1, input2, f1, f2, t, R, X ) ;



  /***********************************/
  /* 3Ԥ */
  /***********************************/
  //normalizeShape( X ) ;



  /*******************************/
  /* 3Ϥ */
  /*******************************/
  if( args_info.reconstruction_output_given ) {
    ofstream ofs ;
    ofs.open( args_info.reconstruction_output_arg ) ;
    ofs << "# 3D data" << endl ;
    ofs << "point" << endl ;
    ofs << "# data num" << endl ;
    ofs << X.size() << endl ;
    ofs << "# begin data" << endl ;
    for( unsigned int i = 0; i < X.size(); i++ ) {
      ofs << X[i][0] << " " << X[i][1] << " " << X[i][2] << endl ;
    }
    ofs << "# end data" << endl ;

    /* ɽ */
//    VecC x(1.0, 0.0, 0.0 ), y( 0, 1.0, 0 ), z( 0, 0, 10 ) ;
//    ofs << "# camera 1" << endl; 
//    ofs << "color" << endl ;
//    ofs << "1 0 0" << endl ;
//    ofs << "line" << endl ;
//    ofs << "3" << endl ;
//    ofs << "0 0 0" << endl ;
//    ofs << x[0] << " " << x[1] << " " << x[2] << endl ;
//    ofs << "0 0 0" << endl ;
//    ofs << y[0] << " " << y[1] << " " << y[2] << endl ;
//    ofs << "0 0 0" << endl ;
//    ofs << z[0] << " " << z[1] << " " << z[2] << endl ;
//
//    x = t + R * x ;
//    y = t + R * y ;
//    z = t + R * z ;
//    ofs << "# camera 2" << endl; 
//    ofs << "color" << endl ;
//    ofs << "0 1 0" << endl ;
//    ofs << "line" << endl ;
//    ofs << "3" << endl ;
//    ofs << t[0] << " " << t[1] << " " << t[2] << endl ;
//    ofs << x[0] << " " << x[1] << " " << x[2] << endl ;
//    ofs << t[0] << " " << t[1] << " " << t[2] << endl ;
//    ofs << y[0] << " " << y[1] << " " << y[2] << endl ;
//    ofs << t[0] << " " << t[1] << " " << t[2] << endl ;
//    ofs << z[0] << " " << z[1] << " " << z[2] << endl ;
//    ofs.close() ;
  } else {
    cout << "# 3D data" << endl ;
    cout << "point" << endl ;
    cout << "# data num" << endl ;
    cout << X.size() << endl ;
    cout << "# begin data" << endl ;
    for( unsigned int i = 0; i < X.size(); i++ ) {
      cout << X[i][0] << " " << X[i][1] << " " << X[i][2] << endl ;
    }
    cout << "# end data" << endl ;
  }

  return 0 ;
}
