/**
 * @file
 * @brief ٥ȥΥ饹
 * @author ()
 */

#include "Vec.h"
#if __GNUC__ >= 3
# include <new>         // std::bad_alloc ꤲʤ褦ˤ뤿
# if defined DEBUG
#  include <limits>     // std::numeric_limits<double>::quiet_NaN()
# endif
#endif

using std::cerr;
using std::endl;
using std::istream;
using std::ostream;

namespace
{
    void  delete_parenthese(char* buff, int len)
    {
        for (int i = 0; buff[i] != '\0' && i < len; i++)
            if (buff[i] == '(' || buff[i] == ')' || buff[i] == 't')
                buff[i] = ' ';
        return;
    }

    char*  next_token(char** p)
    {
        int    i;
        char*  q;

        i = 0;
        q = *p;
        while (q[i] == ' ' || q[i] == '\t')
            i++;
        q += i;
        i = 0;
        while (q[i] != ' ' && q[i] != '\t' && q[i] != '\0')
            i++;

        q[i] = '\0';
        *p = q + i + 1;

        return q;
    }
}

namespace Lab
{
    double*  Vec::allocate(int n)
    {
        double *p, *r;

#if __GNUC__ < 3
        r = p = new double[n];
#else
        r = p = new(std::nothrow) double[n];
#endif
        if (p == NULL)
        {
            cerr << "### Memory Alloc Error (Vec.allocate) ###\n";
            ::abort();
        }

#if __GNUC__ >= 3 && defined DEBUG
        // ˺ˤץȯŤ餤ư򤱤뤿ˡ
        // ͤ NaN (Not a number) ǽƤ
        // (Ψθǡץץåܥ
        // DEBUG ƤΤߡȤ)
        for (int i = 0; i < n; i++)
            *p++ = std::numeric_limits<double>::quiet_NaN();
#endif

        return r;
    }

    // ѹ
    void Vec::renew(int n)
    {
        double *p, *r, *q = vec_;
        int    ni;

        if (n == n_) return;

#if __GNUC__ < 3
        r = p = new double[n];
#else
        r = p = new(std::nothrow) double[n];
#endif
        if (r == NULL)
        {
            cerr << "### Memory Alloc Error (Vec.renew) ###\n";
            ::abort();
        }

        ni = (n < n_) ? n : n_;
        for (int i = 0; i < ni; i++)
            *p++ = *q++;

#if __GNUC__ >= 3 && defined DEBUG
        // ˺ˤץȯŤ餤ư򤱤뤿ˡ
        // ͤ NaN (Not a number) ǽƤ
        // (Ψθǡץץåܥ
        // DEBUG ƤΤߡȤ)
        if (n_ < n)
            for (int i = n_; i < n; i++)
                *p++ = std::numeric_limits<double>::quiet_NaN();
#endif

        delete [] vec_;
        vec_ = r;
        n_ = n;
    }

    // ٥ȥ
    VecC abs(const VecC& V)
    {
        VecC   T(V.n_);
        double *p = T.vec_, *q = V.vec_;

        for (int i = 0; i < T.n_; i++)
            *p++ = fabs(*q++);

        return T;
    }

    VecR abs(const VecR& V)
    {
        VecR   T(V.n_);
        double *p = T.vec_, *q = V.vec_;

        for (int i = 0; i < T.n_; i++)
            *p++ = fabs(*q++);

        return T;
    }

    // ȥ꡼फγǤ
    istream& operator >> (istream& s, Vec& V)
    {
        char    buff[256], *bp, *bq;
        double  *p = V.vec_;

        s.getline(buff, sizeof(buff));
        delete_parenthese(buff, sizeof(buff));
        bp = bq = buff;
        for (int i = 0; i < V.n_; i++)
        {
            bp = next_token(&bq);
            *p++ = atof(bp);
        }
        return s;
    }

    istream& operator >> (istream& s, VecR& V)
    {
        const bool  is_set_skipws = s.flags() & std::ios_base::skipws;
        char        lpar, rpar;
        VecR        v(V.n_);
        double      *p = v.vec_;

        if (!is_set_skipws)
            s.setf(std::ios_base::skipws);
        s >> lpar;
        for (int i = 0; i < v.n_; i++)
            s >> *p++;
        s >> rpar;
        if (!is_set_skipws)
            s.unsetf(std::ios::skipws);
        if (lpar == '(' && rpar == ')')
            V = v;
        else
            s.setstate(std::ios_base::failbit);

        return s;
    }

    istream& operator >> (istream& s, VecC& V)
    {
        const bool  is_set_skipws = s.flags() & std::ios_base::skipws;
        char        lpar, rpar, t;
        VecC        v(V.n_);
        double      *p = v.vec_;

        if (!is_set_skipws)
            s.setf(std::ios_base::skipws);
        s >> lpar;
        for (int i = 0; i < v.n_; i++)
            s >> *p++;
        s >> rpar >> t;
        if (!is_set_skipws)
            s.unsetf(std::ios_base::skipws);
        if (lpar == '(' && rpar == ')' && t == 't')
            V = v;
        else
            s.setstate(std::ios_base::failbit);

        return s;
    }

    // ȥ꡼ؤΥ٥ȥν
    ostream& operator << (ostream& s, const Vec& V)
    {
        double  *p = V.vec_;

        for (int i = 0; i < V.n_; i++, p++)
            s << ((fabs(*p) <= EPS)? 0: *p) << " ";
        return s;
    }

    ostream& operator << (ostream& s, const VecR& V)
    {
        double  *p = V.vec_;

        s << "( ";
        for (int i = 0; i < V.n_; i++, p++)
            s << ((fabs(*p) <= EPS)? 0: *p) << " ";
        s << ")";
        return s;
    }

    ostream& operator << (ostream& s, const VecC& V)
    {
        double  *p = V.vec_;

        s << "( ";
        for (int i = 0; i < V.n_; i++, p++)
            s << ((fabs(*p) <= EPS)? 0: *p) << " ";
        s << ")t";
        return s;
    }

    // 顼Ǥν
    VecR operator / (const VecR& V, double a)
    {
        VecR    T(V);
        double  *p = T.vec_;

        for (int i = 0; i < T.n_; i++)
            *p++ /= a;
        return T;
    }

    VecC operator / (const VecC& V, double a)
    {
        VecC    T(V.n_);
        double  *p = T.vec_, *q = V.vec_;

        for (int i = 0; i < T.n_; i++)
            *p++ = *q++ / a;
        return T;
    }

    // 顼
    VecR operator * (const VecR& V, double a)
    {
        VecR    T(V);
        double  *p = T.vec_;

        for (int i = 0; i < T.n_; i++)
            *p++ *= a;
        return T;
    }

    VecC operator * (const VecC& V, double a)
    {
        VecC    T(V.n_);
        double  *p = T.vec_, *q = V.vec_;

        for (int i = 0; i < T.n_; i++)
            *p++ = *q++ * a;
        return T;
    }

    // 
    double operator , (const VecR& V1, const VecR& V2)
    {
        double  x = 0.0;
        double  *p = V1.vec_, *q = V2.vec_;

        assert(V1.n_ == V2.n_);
        for (int i = 0; i < V1.n_; i++)
            x += (*p++) * (*q++);
        return x;
    }

    double operator , (const VecC& V1, const VecC& V2)
    {
        double  x = 0.0;
        double  *p = V1.vec_, *q = V2.vec_;

        assert(V1.n_ == V2.n_);
        for (int i = 0; i < V1.n_; i++)
            x += (*p++) * (*q++);
        return x;
    }

    // ñ - 黻
    VecR operator - (const VecR& V)
    {
        VecR    T(V.n_);
        double  *p = T.vec_, *q = V.vec_;

        for (int i = 0; i < V.n_; i++)
            *p++ = -(*q++);
        return T;
    }

    VecC operator - (const VecC& V)
    {
        VecC    T(V.n_);
        double  *p = T.vec_, *q = V.vec_;

        for (int i = 0; i < V.n_; i++)
        *p++ = -(*q++);
        return T;
    }

    // ٥ȥΥΥ (ɤǤ褤Ϥ)
    double Vec::norm() const
    {
        return sqrt(this->sqnorm());
    }

    // ٥ȥΥ
    double Vec::sqnorm() const
    {
        double  x = 0;
        double  *p = vec_;

        for (int i = 0; i < n_; i++, p++)
            x += (*p) * (*p);
        return x;
    }

    // ٥ȥ
    VecR normalize(const VecR& V)
    {
        VecR    T(V);
        double  d;

        if ((d = V.norm()) < EPS)
        {
            T.clear(0.0);
            return T;
        }
        else
            return T / d;
    }

    VecC normalize(const VecC& V)
    {
        VecC    T(V);
        double  d;

        if ((d = V.norm()) < EPS)
        {
            T.clear(0.0);
            return T;
        }
        else
            return T / d;
    }

    // Z 
    VecR Znormalize(const VecR& V)
    {
        assert(V.size() == 3);

        return (fabs(V[2]) < EPS) ? VecR(0.0, 0.0, 0.0) : V / V[2];
    }

    VecC Znormalize(const VecC& V)
    {
        assert(V.size() == 3);

        return (fabs(V[2]) < EPS) ? VecC(0.0, 0.0, 0.0) : V / V[2];
    }

    // ٥ȥӡ
    //  ׻(ݤ)θ
    bool operator == (const Vec& V1, const Vec& V2)
    {
        double  *p = V1.vec_, *q = V2.vec_;

        assert(V1.n_ == V2.n_);
        for (int i = 0; i < V1.n_; i++)
            if (fabs(*p++ - *q++) > EPS)
                return false;

        return true;
    }

    // ٥ȥӡ԰
    //  ׻(ݤ)θ
    bool operator != (const Vec& V1, const Vec& V2)
    {
        double  *p = V1.vec_, *q = V2.vec_;
        assert(V1.n_ == V2.n_);
        for (int i = 0; i < V1.n_; i++)
            if (fabs(*p++ - *q++) > EPS)
                return true;

        return false;
    }

    // ٥ȥγ (3x3Τ)
    VecR operator % (const VecR& V1, const VecR& V2)
    {
        double  x[3];

        assert(V1.n_ == 3 && V2.n_ == 3);
        x[0] = V1.vec_[1] * V2.vec_[2] - V1.vec_[2] * V2.vec_[1];
        x[1] = V1.vec_[2] * V2.vec_[0] - V1.vec_[0] * V2.vec_[2];
        x[2] = V1.vec_[0] * V2.vec_[1] - V1.vec_[1] * V2.vec_[0];
        return VecR(x, 3);
    }

    VecC operator % (const VecC& V1, const VecC& V2)
    {
        double  x[3];

        assert(V1.n_ == 3 && V2.n_ == 3);
        x[0] = V1.vec_[1] * V2.vec_[2] - V1.vec_[2] * V2.vec_[1];
        x[1] = V1.vec_[2] * V2.vec_[0] - V1.vec_[0] * V2.vec_[2];
        x[2] = V1.vec_[0] * V2.vec_[1] - V1.vec_[1] * V2.vec_[0];
        return VecC(x, 3);
    }
}
