/**
 * @file
 * @brief ٥ȥΥ饹
 * @author ()
 */

#ifndef KANAZAWA_LAB_VEC_H_INCLUDED
#define KANAZAWA_LAB_VEC_H_INCLUDED

#if __GNUC__ < 3
# include <iostream.h>
# include <math.h>
# include <stdlib.h>
# include <assert.h>
#else
# include <iostream>
# include <cmath>
# include <cstdlib>
# include <cassert>
# include <new>         // std::bad_alloc ꤲʤ褦ˤ뤿
# if defined DEBUG
#  include <limits>     // std::numeric_limits<double>::quiet_NaN()
# endif
#endif

#if !defined DEPRECATED
# if defined __GNUC__
#  define DEPRECATED __attribute__((deprecated))
# else
#  define DEPRECATED
# endif
#endif

/**
 * ͸
 * @note ץ˥Хɬ
 */
extern double EPS;

/// ͸(󼰷׻)
extern double DET_EPS;

/// 漼饤֥ζ̾
namespace Lab
{
    const int DEFAULT_SIZE = 3;     ///< ٥ȥΥǥեȼ

    class Mat;
    class Vec;
    class VecR;
    class VecC;

    /// ٥ȥΰ̷
    class Vec
    {
        friend class Mat;

        /**
         * @a n Υ٥ȥ뤬Ѥΰݤ롥
         * @brief ٥ȥΥΰݤ롥
         * @param [in] n 
         * @return ݤΰƬǤؤΥݥ
         */
        static double*  allocate(int n);

    protected:  // 饹(VecC, VecR)ǥΤǥץƥ
        double* vec_;   ///< ٥ȥ
        int     n_;     ///< ٥ȥμ

        /**
         * @a n Υ٥ȥ륳󥹥ȥ饯
         * @brief 󥹥ȥ饯
         * @param [in] n 
         */
        explicit Vec(int n) : vec_(allocate(n)), n_(n) {}

        /**
         * @a n Υ٥ȥ륳󥹥ȥ饯
         * Ǥͤ @a v Ǽ줿ͤѤ롥
         * @brief 󥹥ȥ饯
         * @param [in] v Ǥͤä
         * @param [in] n ٥ȥμ
         */
        explicit Vec(const double* v, int n = DEFAULT_SIZE)
            : vec_(allocate(n)), n_(n)
        {
            double*       p = vec_;
            const double* q = v;
            for (int i = 0; i < n_; i++)
                *p++ = *q++;
        }

        /**
         * Ǥ @a d1, @a d2, @a d3 Ǥ 3 Υ٥ȥ륳
         * ȥ饯
         * @brief 󥹥ȥ饯
         * @param [in] d1 1Ǥ
         * @param [in] d2 2Ǥ
         * @param [in] d3 3Ǥ
         */
        Vec(double d1, double d2, double d3) : vec_(allocate(3)), n_(3)
        {
            double* p = vec_;
            *p++ = d1; *p++ = d2; *p++ = d3;
        }

        /**
         * @brief ԡ󥹥ȥ饯
         * @param [in] V ԡ
         */
        Vec(const Vec& V) : vec_(allocate(V.n_)), n_(V.n_)
        {
            double*       p = vec_;
            const double* q = V.vec_;
            for (int i = 0; i < n_; i++)
                *p++ = *q++;
        }

        /**
         * @brief ǥȥ饯
         */
        virtual ~Vec()
        {
            delete [] vec_;
#if defined DEBUG
            vec_ = 0;
#endif
        }

    public:
        /**
         * ٥ȥ @a i ܤǤ򻲾Ȥ롥
         * @brief ٥ȥǤ򻲾Ȥ롥
         * @param [in] i ФǤź
         * @return ٥ȥǤλ
         */
        double& operator [] (int i) const
        {
            assert((i >= 0) && (i < n_));
            return *(vec_ + i);
        }

        /**
         * ٥ȥ @a a γǤͤ롥
         * @brief ٥ȥͤ롥
         * @param [in] a ͤ
         * @return 
         */
        Vec& operator = (const double a[])
        {
            double*       p = vec_;
            const double* q = a;
            for (int i = 0; i < n_; i++)
                *p++ = *q++;
            return *this;
        }

        /**
         * ٥ȥγǤ˥ @a a 褸롥
         * @brief ٥ȥ˥褸롥
         * @param [in] a 
         * @return 黻
         */
        Vec& operator *= (double a)
        {
            double* p = vec_;
            for (int i = 0; i < n_; i++)
                *p++ *= a;
            return *this;
        }

        /**
         * ٥ȥγǤ򥹥 @a a ǳ롥
         * @brief ٥ȥ򥹥ǳ롥
         * @param [in] a 
         * @return 黻
         */
        Vec& operator /= (double a)
        {
            double* p = vec_;
            for (int i = 0; i < n_; i++)
                *p++ /= a;
            return *this;
        }

        /**
         * ٥ȥμ @a n ѹ롥
         * @brief ٥ȥμѹ롥
         * @param [in] n 
         */
        void renew(int n);

        /**
         * @brief ٥ȥΥΥ롥
         * @return ٥ȥΥΥ
         */
        double norm() const;

        /**
         * @brief ٥ȥ2Υ롥
         * @return ٥ȥ2Υ
         */
        double sqnorm() const;

        /**
         * @brief ٥ȥ2Υ롥
         * @note "sqrt (= square root)" դߤС"sqrnorm" ǤϤʤ
         *       "sqnorm" ؿ̾ȤŬڤȻפ롥
         * @sa Vec::sqnorm()
         */
        DEPRECATED double sqrnorm() const { return sqnorm(); }

        /**
         * @brief ٥ȥμ롥
         * @return ٥ȥμ
         */
        int size() const { return n_; }

        /**
         * ٥ȥǤ @a data ǽ롥
         * @brief Ǥ롥
         * @param [in] data 
         */
        void clear(double data = 0.0)
        {
            double* p = vec_;
            for (int i = 0; i < n_; i++)
                *p++ = data;
        }

        /**
         * ȥ꡼ @a s ٥ȥ @a V ɤ߹ࡥ
         * @brief ȥ꡼फ٥ȥɤ߹ࡥ
         * @param [in,out] s ϥȥ꡼
         * @param [out] V ٥ȥ
         * @sa operator >> (istream&, VecR&)
         * @sa operator >> (istream&, VecC&)
         */
#if __GNUC__ < 3
        friend istream& operator >> (istream& s, Vec& V);
#else
        friend std::istream& operator >> (std::istream& s, Vec& V);
#endif

        /**
         * ٥ȥ @a V 򥹥ȥ꡼ @a s ˽Ϥ롥
         * @brief ٥ȥ򥹥ȥ꡼˽Ϥ
         * @param [in,out] s ϥȥ꡼
         * @param [in] V ٥ȥ
         * @sa operator << (ostream&, const VecR&)
         * @sa operator << (ostream&, const VecC&)
         */
#if __GNUC__ < 3
        friend ostream& operator << (ostream& s, const Vec& V);
#else
        friend std::ostream& operator << (std::ostream& s, const Vec& V);
#endif

        /**
         * ٥ȥ @a V1  @a V2 ɤĴ٤롥
         * @brief ٥ȥ뤬Ĵ٤
         * @param [in] V1 
         * @param [in] V2 
         * @retval true @a V1  @a V2 
         * @retval false @a V1  @a V2 ʤ
         */
        friend bool operator == (const Vec& V1, const Vec& V2);

        /**
         * ٥ȥ @a V1  @a V2 ʤɤĴ٤롥
         * @brief ٥ȥ뤬ʤĴ٤
         * @param [in] V1 
         * @param [in] V2 
         * @retval true @a V1  @a V2 ʤ
         * @retval false @a V1  @a V2 
         */
        friend bool operator != (const Vec& V1, const Vec& V2);

        friend double sqnorm(const Vec& V);
    };

    /// ԥ٥ȥ
    class VecR : public Vec
    {
    public:
        /**
         * @brief 󥹥ȥ饯
         * @sa Vec(int)
         */
        explicit VecR(int n = DEFAULT_SIZE) : Vec(n) {}

        /**
         * @brief 󥹥ȥ饯
         * @sa Vec(const double*, int)
         */
        explicit VecR(const double* v, int n = DEFAULT_SIZE) : Vec(v, n) {}

        /**
         * @brief 󥹥ȥ饯
         * @sa Vec(double, double, double)
         */
        VecR(double d1, double d2, double d3) : Vec(d1, d2, d3) {}

        /**
         * @brief ԡ󥹥ȥ饯
         * @param [in] RV ԡ
         */
        VecR(const VecR& RV) : Vec(RV) {}

        /**
         * ٥ȥμ @a n ѹ롥
         * @brief ٥ȥμѹ롥
         * @param [in] n 
         * @sa Vec::renew(int)
         * @sa VecC::realloc(int)
         */
        void realloc(int n)
        {
            Vec::renew(n);
        }

        /**
         * ٥ȥ @a RV 롥
         * @brief 黻
         * @param [in] RV 
         * @return 
         */
        VecR& operator = (const VecR& RV)
        {
            double*       p = vec_;
            const double* q = RV.vec_;
            if (this == &RV) return *this;
            assert(RV.n_ == n_);
            for (int i = 0; i < n_; i++)
                *p++ = *q++;
            return *this;
        }

        /**
         * ߤΥ٥ȥ @a RV û롥
         * @brief û黻
         * @param [in] RV 
         * @return 黻
         */
        VecR& operator += (const VecR& RV)
        {
            double*       p = vec_;
            const double* q = RV.vec_;
            assert(RV.n_ == n_);
            for (int i = 0; i < n_; i++)
                *p++ += *q++;
            return *this;
        }

        /**
         * ߤΥ٥ȥ뤫 @a RV 򸺻롥
         * @brief 黻
         * @param [in] RV 
         * @return 黻
         */
        VecR& operator -= (const VecR& RV)
        {
            double*       p = vec_;
            const double* q = RV.vec_;
            assert(RV.n_ == n_);
            for (int i = 0; i < n_; i++)
                *p++ -= *q++;
            return *this;
        }

        /**
         * ԥ٥ȥ @a V 򥹥 @a a ǳä٥ȥ롥
         * @brief ԥ٥ȥ򥹥ǳ롥
         * @param [in] V ԥ٥ȥ
         * @param [in] a 
         * @return 黻
         * @sa VecC::operator / (const VecC&, double)
         */
        friend VecR operator / (const VecR& V, double a);

        /**
         * ԥ٥ȥ @a V 򥹥 @a a ܤ٥ȥ롥
         * @brief ԥ٥ȥ򥹥ܤ롥
         * @param [in] V ԥ٥ȥ
         * @param [in] a 
         * @return 黻
         * @sa VecC::operator * (const VecC&, double)
         */
        friend VecR operator * (const VecR& V, double a);

        friend VecR operator * (double a, const VecR& V);
        friend double operator * (const VecR& RV, const VecC& CV);

        /**
         * ԥ٥ȥ @a V1  @a V2 Ѥ롥
         * @brief ԥ٥ȥƱΤѤ롥
         * @param [in] V1 դιԥ٥ȥ
         * @param [in] V2 դιԥ٥ȥ
         * @return @a V1  @a V2 
         * @sa VecC::operator , (const VecC&, const VecC&)
         */
        friend double operator , (const VecR& V1, const VecR& V2);

        friend VecC operator ~ (const VecR& V);

        /**
         * ԥ٥ȥ @a V1  @a V2 γѤ롥
         * @brief ԥ٥ȥƱΤγѤ롥
         * @param [in] V1 դιԥ٥ȥ
         * @param [in] V2 դιԥ٥ȥ
         * @return @a V1  @a V2 γ
         * @sa VecC::operator % (const VecC&, const VecC&)
         */
        friend VecR operator % (const VecR& V1, const VecR& V2);

        friend VecR operator + (const VecR& V1, const VecR& V2);
        friend VecR operator - (const VecR& V1, const VecR& V2);

        /**
         * ԥ٥ȥ @a V γǤȿž٥ȥ롥
         * @brief ԥ٥ȥγǤȿž٥ȥ롥
         * @param [in] V ԥ٥ȥ
         * @return Ǥȿž٥ȥ
         * @sa VecR::operator - (const VecR&)
         */
        friend VecR operator - (const VecR& V);

        /**
         * ԥ٥ȥ @a V γǤͤȤä٥ȥ롥
         * @brief ԥ٥ȥγǤͤ롥
         * @param [in] V ԥ٥ȥ
         * @return ǤͤǤ˻Ĺԥ٥ȥ
         * @sa VecC::abs(const VecC&)
         */
        friend VecR abs(const VecR& V);

#if __GNUC__ < 3
        /**
         * ȥ꡼ @a s ԥ٥ȥ @a V ɤ߹ࡥ
         * @brief ȥ꡼फԥ٥ȥɤ߹ࡥ
         * @param [in,out] s ϥȥ꡼
         * @param [out] V ٥ȥ
         * @sa operator >> (istream&, Vec&)
         * @sa operator >> (istream&, VecC&)
         */
        friend istream& operator >> (istream& s, VecR& V);
#else
        /**
         * ȥ꡼ @a s ԥ٥ȥ @a V ɤ߹ࡥ
         * @brief ȥ꡼फԥ٥ȥɤ߹ࡥ
         * @param [in,out] s ϥȥ꡼
         * @param [out] V ٥ȥ
         * @sa operator >> (std::istream&, Vec&)
         * @sa operator >> (std::istream&, VecC&)
         */
        friend std::istream& operator >> (std::istream& s, VecR& V);
#endif

        /**
         * ԥ٥ȥ @a V 򥹥ȥ꡼ @a s ˽Ϥ롥
         * @brief ԥ٥ȥ򥹥ȥ꡼˽Ϥ
         * @param [in,out] s ϥȥ꡼
         * @param [in] V ٥ȥ
         * @sa operator << (ostream&, const Vec&)
         * @sa operator << (ostream&, const VecC&)
         */
#if __GNUC__ < 3
        friend ostream& operator << (ostream& s, const VecR& V);
#else
        friend std::ostream& operator << (std::ostream& s, const VecR& V);
#endif
    };

    /// ٥ȥ
    class VecC : public Vec
    {
    public:
        /**
         * @brief 󥹥ȥ饯
         * @sa Vec(int)
         */
        explicit VecC(int n = DEFAULT_SIZE) : Vec(n) {}

        /**
         * @brief 󥹥ȥ饯
         * @sa Vec(const double*, int)
         */
        explicit VecC(const double* v, int n = DEFAULT_SIZE) : Vec(v, n) {}

        /**
         * @brief 󥹥ȥ饯
         * @sa Vec(double, double, double)
         */
        VecC(double d1, double d2, double d3) : Vec(d1, d2, d3) {}

        /**
         * @brief ԡ󥹥ȥ饯
         * @param [in] CV ԡ
         */
        VecC(const VecC& CV) : Vec(CV) {}

        /**
         * ٥ȥμ @a n ѹ롥
         * @brief ٥ȥμѹ롥
         * @param [in] n 
         * @sa Vec::renew(int)
         * @sa VecR::realloc(int)
         */
        void realloc(int n)
        {
            Vec::renew(n);
        }

        /**
         * @brief 黻
         * @sa VecR::operator = (const double a[])
         */
        VecC& operator = (const double a[])
        {
            double*       p = vec_;
            const double* q = a;
            for (int i = 0; i < n_; i++)
                *p++ = *q++;
            return *this;
        }

        /**
         * @brief 黻
         * @sa VecR::operator = (const VecR&)
         */
        VecC& operator = (const VecC& CV)
        {
            double*       p = vec_;
            const double* q = CV.vec_;
            if (this == &CV) return *this;
            assert(CV.n_ == n_);
            for (int i = 0; i < n_; i++)
                *p++ = *q++;
            return *this;
        }

        /**
         * @brief û黻
         * @sa VecR::operator += (const VecR&)
         */
        VecC& operator += (const VecC& CV)
        {
            double*       p = vec_;
            const double* q = CV.vec_;
            assert(CV.n_ == n_);
            for (int i = 0; i < n_; i++)
                *p++ += *q++;
            return *this;
        }

        /**
         * @brief 黻
         * @sa VecR::operator -= (const VecR&)
         */
        VecC& operator -= (const VecC& CV)
        {
            double*       p = vec_;
            const double* q = CV.vec_;
            assert(CV.n_ == n_);
            for (int i = 0; i < n_; i++)
                *p++ -= *q++;
            return *this;
        }

        /**
         * @brief ٥ȥ򥹥ǳ롥
         * @sa operator / (const VecR&, double)
         */
        friend VecC operator / (const VecC& V, double a);

        /**
         * @brief ٥ȥ򥹥ܤ롥
         * @sa operator * (const VecR&, double)
         */
        friend VecC operator * (const VecC& V, double a);

        friend double operator * (const VecR& RV, const VecC& CV);

        friend VecC operator * (double a, const VecC& V);

        /**
         * @brief ٥ȥƱΤѤ롥
         * @sa operator , (const VecR&, const VecR&)
         */
        friend double operator , (const VecC& V1, const VecC& V2);

        friend VecR operator ~ (const VecC& V);

        /**
         * @brief ٥ȥƱΤγѤ롥
         * @sa operator % (const VecR&, const VecR&)
         */
        friend VecC operator % (const VecC& V1, const VecC& V2);

        friend VecC operator + (const VecC& V1, const VecC& V2);
        friend VecC operator - (const VecC& V1, const VecC& V2);

        /**
         * @brief ٥ȥγǤȿž٥ȥ롥
         * @sa VecR::operator - (const VecR&)
         */
        friend VecC operator - (const VecC& V);

        /**
         * @brief ٥ȥγǤͤ롥
         * @sa VecR::abs(const VecR&)
         */
        friend VecC abs(const VecC& V);

        /**
         * @brief ٥ȥ򥹥ȥ꡼फɤ߽Ф
         * @sa operator >> (istream&, Vec&)
         * @sa operator >> (istream&, VecR&)
         */
#if __GNUC__ < 3
        friend istream& operator >> (istream& s, VecC& V);
#else
        friend std::istream& operator >> (std::istream& s, VecC& V);
#endif

        /**
         * @brief ٥ȥ򥹥ȥ꡼˽Ϥ롥
         * @sa operator << (ostream&, const Vec&)
         * @sa operator << (ostream&, const VecR&)
         */
#if __GNUC__ < 3
        friend ostream& operator << (ostream& s, const VecC& V);
#else
        friend std::ostream& operator << (std::ostream& s, const VecC& V);
#endif
    };

    /**
     * ٥ȥ @a V ž֤롥
     * @brief ٥ȥž֤롥
     * @param [in] V ٥ȥ
     * @return @a V ž
     */
    inline VecR operator ~ (const VecC& V)
    {
        return VecR(V.vec_, V.n_);
    }

    /**
     * ԥ٥ȥ @a V ž֤롥
     * @brief ԥ٥ȥž֤롥
     * @param [in] V ԥ٥ȥ
     * @return @a V ž
     */
    inline VecC operator ~ (const VecR& V)
    {
        return VecC(V.vec_, V.n_);
    }

    /**
     * ԥ٥ȥ @a V1  @a V2 ¤롥
     * @brief ԥ٥ȥ¤롥
     * @param [in] V1 
     * @param [in] V2 
     * @return 黻
     */
    inline VecR operator + (const VecR& V1, const VecR& V2)
    {
        VecR T(V1);
        return T += V2;
    }

    /**
     * ٥ȥ @a V1  @a V2 ¤롥
     * @brief ٥ȥ¤롥
     * @param [in] V1 
     * @param [in] V2 
     * @return 黻
     */
    inline VecC operator + (const VecC& V1, const VecC& V2)
    {
        VecC T(V1);
        return T += V2;
    }

    /**
     * ԥ٥ȥ @a V1  @a V2 κ롥
     * @brief ԥ٥ȥκ롥
     * @param [in] V1 
     * @param [in] V2 
     * @return 黻
     */
    inline VecR operator - (const VecR& V1, const VecR& V2)
    {
        VecR T(V1);
        return T -= V2;
    }

    /**
     * ٥ȥ @a V1  @a V2 κ롥
     * @brief ٥ȥκ롥
     * @param [in] V1 
     * @param [in] V2 
     * @return 黻
     */
    inline VecC operator - (const VecC& V1, const VecC& V2)
    {
        VecC T(V1);
        return T -= V2;
    }

    /**
     *  @a a ٥ȥ @a V1 Ѥ롥
     * @brief ٥ȥѤ롥
     * @param [in] a 
     * @param [in] V 
     * @return 黻
     */
    inline VecC operator * (double a, const VecC& V)
    {
        return V * a;
    }

    /**
     *  @a a ȹԥ٥ȥ @a V1 Ѥ롥
     * @brief ȹԥ٥ȥѤ롥
     * @param [in] a 
     * @param [in] V 
     * @return 黻
     */
    inline VecR operator * (double a, const VecR& V)
    {
        return V * a;
    }

    /**
     * ԥ٥ȥ @a RV ٥ȥ @a CV Ѥ롥
     * @brief ԥ٥ȥ٥ȥѤ롥
     * @param [in] RV ԥ٥ȥ
     * @param [in] CV ٥ȥ
     * @return @a RV  @a CV 
     */
    inline double operator * (const VecR& RV, const VecC& CV)
    {
        return ((~RV) , CV);
    }

    /**
     * ٥ȥ @a V ΥΥ롥
     * @brief ٥ȥΥΥ롥
     * @param [in] V ٥ȥ
     * @return ٥ȥ @a V ΥΥ
     */
    inline double norm(const Vec& V)
    {
        return V.norm();
    }

    /**
     * ٥ȥ @a V  2 Υ롥
     * @brief ٥ȥ 2 Υ롥
     * @param [in] V ٥ȥ
     * @return ٥ȥ @a V  2 Υ
     */
    inline double sqnorm(const Vec& V)
    {
        return V.sqnorm();
    }

    /**
     * @brief ٥ȥ 2 Υ롥
     * @sa Vec::sqrnorm()
     */
    DEPRECATED inline double sqrnorm(const Vec& V)
    {
        return V.sqnorm();
    }

    /**
     * ԥ٥ȥ @a V ΥΥब 1 ˤʤ褦롥
     * @brief ԥ٥ȥ롥
     * @param [in] V ԥ٥ȥ
     * @return ιԥ٥ȥ
     * @sa VecC::normalize(const VecC&)
     */
    VecR normalize(const VecR& V);

    /**
     * @brief ٥ȥ롥
     * @sa VecR::normalize(const VecR&)
     */
    VecC normalize(const VecC& V);

    /**
     * ԥ٥ȥ @a V  3 Ǥ 1 ˤʤ褦롥
     * @brief ԥ٥ȥ Z 롥
     * @param [in] V ԥ٥ȥ
     * @return ιԥ٥ȥ
     * @sa VecC::Znormalize(const VecC&)
     */
    VecR Znormalize(const VecR& V);

    /**
     * @brief ٥ȥ Z 롥
     * @sa VecR::Znormalize(const VecR&)
     */
    VecC Znormalize(const VecC& V);

    /**
     * @brief ԥ٥ȥ Z 롥
     * @note VecR::normalize() ڤ ::norm() դߤС"Znorm" ǤϤʤ
     *       "Znormalize" ؿ̾ȤŬڤȻפ롥
     * @sa VecR::Znormalize(const VecR&)
     * @sa VecC::Znorm(const VecC&)
     */
    DEPRECATED inline VecR Znorm(const VecR& V)
    {
        return Znormalize(V);
    }

    /**
     * @brief ٥ȥ Z 롥
     * @sa VecC::Znormalize(const VecC&)
     * @sa VecR::Znorm(const VecR&)
     */
    DEPRECATED inline VecC Znorm(const VecC& V)
    {
        return Znormalize(V);
    }
}

// Υץबɬפʤ˥ѥǽʤ褦ǥեȤǤ
// using namespace Ƥ(ͥ褹롤Ȥ̣)
// ̾ͤ(㤨и漼饤֥ CImage  OpenCV 饤֥
// CImage ξ)ϡѥΥץȤ
//   gcc -DUSE_NAMESPACE
// Ϳ뤳Ȥˤäơξͤ򤱤뤳ȤǤ롥
// 漼饤֥λѻŪֻ꤬̾ɬפȤʤ롥
#if !defined USE_NAMESPACE
using namespace Lab;
#endif

#endif  // KANAZAWA_LAB_VEC_H_INCLUDED

