#include <vector>
#include "Vec.h"
#include "Mat.h"

#define f 600.0
#define UPDATE 1

/**
 * @file read.cc
 * @brief ե뤫бɤ߹
 * @param filename б򵭽Ҥե̾
 * @param cooridinate ɤ߹бǼ٥
 * @author Kento YAMADA
 * @date 2008.10.31
 */
void read( const char *filename, std::vector< VecC > &coordinate ) ;


/**
 * @file read.cc
 * @brief ե뤫бɤ߹
 * @param filename б򵭽Ҥե̾
 * @param cooridinate ɤ߹бǼ٥
 * @author Kento YAMADA
 * @date 2008.10.31
 */
void read( const char *filename, std::vector< VecC > &x1, std::vector< VecC > &x2 ) ;


/**
 * @file read3D.cc
 * @brief ե뤫3ɤ߹
 * @param filename б򵭽Ҥե̾
 * @param cooridinate ɤ߹3Ǽ٥
 * @author Kento YAMADA
 * @date 2008.10.31
 */
void read3D( const char *filename, std::vector< VecC > &coordinate ) ;


/**
 * @file initLSM.cc
 * @brief ǾˡѤƴù׻ΤνԤ
 * @param x1 x2 бȤǼ٥
 * @return u ñ̥٥ȥ
 * @author Kento YAMADA
 * @date 2008.10.31
 */
VecC initLSM( const std::vector< VecC > x1, const std::vector< VecC > x2 ) ;


/**
 * @file hartley.cc
 * @brief 8르ꥺѤƴù׻
 * @param x1 x2 бȤǼ٥
 * @return u 9ñ̥٥ȥ
 * @author Kento YAMADA
 * @date 2009.1.8
 */
VecC hartley( const std::vector< VecC > x1, const std::vector< VecC > x2 ) ;


/**
 * @file initTaubin.cc
 * @brief TaubinˡѤƴù׻ΤνԤ
 * @param x1 x2 бȤǼ٥
 * @return u ñ̥٥ȥ
 * @author Kento YAMADA
 * @date 2008.10.31
 */
VecC initTaubin( const std::vector< VecC > x1, const std::vector< VecC > x2 ) ;


/**
 * @file setFundamental.cc
 * @brief 9ñ̥٥ȥ u ù F ׻
 * @param u ñ̥٥ȥ u
 * @return F ù
 * @author Kento YAMADA
 * @date 2008.10.31
 */
Mat setFundamental( const VecC u ) ;


/**
 * @file setFundamental.cc
 * @brief ù F  9 ñ̥٥ȥѴ
 * @param F ù
 * @return u  9 ñ̥٥ȥ u
 * @author Kento YAMADA
 * @date 2009.4.22
 */
VecC setFundamental( const Mat F ) ;


/**
 * @file calcFundamental.cc
 * @brief ù F ׻,ħȤ
 * @param x1 x2 бȤǼ٥
 * @param u ñ̥٥ȥ u
 * @param epsilon «ȽѤο
 * @return ǽŪʺƸ
 * @author Kento YAMADA
 * @date 2008.11.17
 */
Mat correctCorrespondingPoints( std::vector<VecC> &x1, std::vector<VecC> &x2,
                     VecC u, const double epsilon, double &E,
                     const int update = 0 ) ;


/**
 * @file initParam.cc
 * @brief б˻Ѥѥ᡼ν
 * @param ѥ᡼
 * @author Kento YAMADA
 * @date 2009.6.19
 */
void initParam( std::vector< VecC > &x1, std::vector< VecC > &x2,
                std::vector< VecC > &x1_hat, std::vector< VecC > &x2_hat,
                std::vector< VecC > &x1_tilde, std::vector< VecC > &x2_tilde ) ;


/**
 * @file initParam.cc
 * @brief б˻Ѥѥ᡼ν
 * @param ѥ᡼
 * @author Kento YAMADA
 * @date 2009.6.19
 */
void updateParam( std::vector< VecC > &x1, std::vector< VecC > &x2,
                  std::vector< VecC > &x1_hat, std::vector< VecC > &x2_hat,
                  std::vector< VecC > &x1_tilde, std::vector< VecC > &x2_tilde,
                  const std::vector< VecC > &xi, const std::vector< Mat > &V_0,
                  const VecC u ) ;




/**
 * @file reviceCorrespond.cc
 * @brief б
 * @param x1 x2 бȤǼ٥
 * @param u ñ̥٥ȥ u
 * @param epsilon «ȽѤο
 * @return E Ƹ
 * @author Kento YAMADA
 * @date 2009.6.18
 */
double reviceCorrespond( std::vector< VecC > &x1, std::vector< VecC > &x2,
		     VecC u, const double epsilon ) ;


/**
 * @file EFNS.cc
 * @brief 9٥ȥ u ιԤ
 * @param u 9٥ȥ u
 * @param xi 9٥ȥ \xi_{alpha}
 * @param V_0 9x9 \V_0
 * @param epsilon «ȽѤο
 * @return 9٥ȥ
 * @author Kento YAMADA
 * @date 2008.11.17
 */
VecC EFNS( VecC &u, const std::vector< VecC > xi,
           const std::vector< Mat > V_0, double epsilon) ;


/**
 * @file judgeFix.cc
 * @brief ù󤫤顤ȽԤ
 * @param F ù
 * @param threshold Ƚꤹ
 * @return True Flase ʤ True ʤ False ֤
 * @author Kento YAMADA
 * @param 2008.11.19
 */
bool judgeFocus( const Mat F, const double threshold ) ;



/**
 * @file judgeIsosceles.cc
 * @bief ֤ջѷݤȽԤ
 * @param F ù
 * @return True False ջѷʤ True 򡤤Ǥʤ False ֤
 * @author Kento YAMADA
 * @param 2009.2.6
 */
bool judgeIsosceles( const Mat F ) ;


/**
 * @file calcKparameter.cc
 * @brief ΥΥѥ᡼׻
 * @param F ù
 * @author Kento YAMADA
 * @date 2009.4.1
 */
void calcKparameter( const Mat F, double &a1, double &a2, double &a3, double &a4, double &a5 ) ;


/**
 * @file calcK.cc
 * @brief Υ׻˻Ѥ K(eta, xi) 
 * @param F ù
 * @author Kento YAMADA
 * @date 2009.7.23
 */
void calcK( const Mat F ) ;


/**
 * @file calcNotFixFocus.cc
 * @brief ǤʤξΥη׻
 * @param F ù
 * @param f1, f2 ׻ΥǼ
 * @author Kento YAMADA
 * @date 2008.11.19
 */
void calcNotFixFocus( const Mat F, double &f1, double &f2 ) ;


/**
 * @file calcNotFixFocusAvg.cc
 * @brief ͳΥˡʿͤǾΥ׻
 * @param F ù
 * @param f1, f2 ׻ΥǼ
 * @author Kento YAMADA
 * @date 2009.7.15
 */
void calcNotFixFocusAvg( const Mat F, double &f1, double &f2 ) ;


/**
 * @file calcFixFocus.cc
 * @brief ξξΥη׻(˥塼ȥˡ)
 * @param F ù
 * @param f1, f2 ׻ΥǼ
 * @author Kento YAMADA
 * @date 2008.11.19
 */
void calcFixFocus( const Mat F, double &f1, double &f2 ) ;


/**
 * @file calcFixFocusAnalysis.cc
 * @brief ξξΥη׻(Ūˡ)
 * @param F ù
 * @param f1, f2 ׻ΥǼ
 * @author Kento YAMADA
 * @date 2008.12.18
 */
void calcFixFocusAnalysis( const Mat F, double &f1, double &f2 ) ;


/**
 * @file calcMotion.cc
 * @brief ưѥ᡼
 * @param x1 x2 ħ
 * @param F ù
 * @param f1 f2 Υ
 * @param t ᤿¿ʤǼ
 * @param R ᤿ž󤬳Ǽ
 * @author Kento YAMADA
 * @date 2008.11.21
 */
void calcMotion( std::vector< VecC > &x1, std::vector< VecC > &x2,
                 const Mat F, const double f1, const double f2,
                 VecC &t, Mat &R ) ;


/**
 * @file calc3DPosition.cc
 * @briedf 3֤
 * @param x1 x2 ħο
 * @param f1 f2 ƥξΥ
 * @param t ¿ʥѥ᡼
 * @param R ž
 * @param X 3֤Ǽ٥ȥ
 * @author Kento YAMADA
 * @date 2008.11.22
 */

void calc3DPosition( std::vector< VecC > &x1, std::vector< VecC > &x2,
                     const double f1, const double f2,
                     VecC &t, const Mat R, std::vector< VecC > &X ) ;


/**
 * @file diffMat.cc
 * @bierf 2Ĥικ
 * @param m1 m2 
 * @return diff 2Ĥικ
 * @author Kento YAMADA
 * @date 2008.11.18
 */
double diffMat( Mat m1, Mat m2 ) ;


/**
 * @normalizeShape.cc
 * @brief 3Ԥ
 * @param shape 3
 * @author Kento YAMADA
 * @date 2008.11.23
 */
void normalizeShape( std::vector< VecC > &shape ) ;


/**
 * @file calcDiffShape.cc
 * @brief 2Ĥ3θ
 * @param shape1 shape2 2Ĥ3
 * @return 
 * @author Kento YAMADA
 * @date 2008.11.23
 */
double calcDiffShape( std::vector< VecC > shape1, std::vector< VecC > shape2 ) ;



/**
 * @file calcXi.cc
 * @brief 9٥ȥ \xi ׻
 * @param x1,x2 ׻Ѥб
 * @return xi 9٥ȥ \xi
 * @author Kento YAMADA
 * @date 2008.12.23
 */
VecC calcXi( const VecC h1, const VecC h2, const VecC t1 = VecC (0,0,0), const VecC t2 = VecC(0,0,0) ) ;



/**
 * @file calcV0.cc
 * @brief 9x9\mV_0 ׻
 * @param x1,x2, ׻Ѥб
 * @return V0 9x9оι \mV_0
 * @author Kento YAMADA
 * @date 2009.12.23
 */
Mat calcV0( const VecC x1, const VecC x2 ) ;


/**
 * @file calcReProjectionErr.cc
 * @brief Ƹ׻
 * @param x1, x2 б
 * @return E Ƹ
 * @author Kento YAMADA
 * @date 2009.4.22
 */
double calcReProjectionErr( const std::vector< VecC > x1, const std::vector< VecC > x2 ) ;


/**
 * @file calcReProjectionErr.cc
 * @brief Ƹ׻
 * @param x1, x2 б
 * @param F ù
 * @return E Ƹ
 * @author Kento YAMADA
 * @date 2009.4.22
 */
double calcReProjectionErr( const double **x1, const double **x2, const Mat F ) ;
