#include <iostream>
#include "solve3DEquation.h"

using namespace std ;

/**
 * @file solve3DEquation.cc
 * @brief ax^3 + bx^2 + cx + d = 0 η3
 * @param a b c d 3Υѥ᡼
 * @author Kento YAMADA
 * @date 2009.2.10
 */
void solve3DEquation( const double a1, const double a2, const double a3, const double a4,
                      double &x1, double &x2, double &x3 ) {

  cout << "# Mathematica  : Solve[ " << a1 << "x^3 + " << a2 << "x^2 + " << a3 << "x + " << a4 << " == 0.0, x]" << endl ;

  /* x^3 + ax^2 + bx + c = 0 η(ξդ a1 ǳ) */
  double a = a2 / a1 ;
  double b = a3 / a1 ;
  double c = a4 / a1 ;
  double Q, R ;

  /* Ƚ̼׻ */
  Q = ( (a * a) - (3.0 * b) ) / 9.0 ;
  R = ( ( 2.0 * a * a * a ) - ( 9.0 * a * b ) + ( 27.0 * c ) ) / 54.0 ;


  /* Ƚ̼ѤơºοĴ٤ */
  if ( ((Q*Q*Q)-(R*R)) >= 0.0 ) {
    /* Ĥμº */
    cout << "# Ĥμº" << endl ;
    double theta = acos( R / sqrt(Q*Q*Q) ) ;
    x1 = -2.0 * sqrt(Q) * cos(theta/3.0) - (a/3.0) ;
    x2 = -2.0 * sqrt(Q) * cos((theta + 2.0*M_PI)/3.0) - (a/3.0) ;
    x3 = -2.0 * sqrt(Q) * cos((theta + 4.0*M_PI)/3.0) - (a/3.0) ;

    /* x1 >= x2 >= x3 Ȥʤ褦˥ */
    if( x1 < x2 && x2 < x3 ) {
      swap( x1, x3 ) ;
    } else if( x1 < x2 && x2 > x3 ) {
      if( x1 < x3 ) {
        swap( x1, x2 ) ;
	swap( x2, x3 ) ;
      } else {
        swap( x1, x2 ) ;
      }
    } else if( x1 > x2 && x2 < x3 ) {
      if( x1 < x3 ) {
        swap( x2, x3 ) ;
        swap( x1, x2 ) ;
      } else {
        swap( x2, x3 ) ;
      }
    }
  } else {
    /* Ĥμº */
    cout << "# Ĥμº" << endl ;
    if ( R < 0.0 ) {
      x1 = ( pow(sqrt((R*R)-(Q*Q*Q))+fabs(R),1.0/3.0) + (Q / pow(sqrt((R*R)-(Q*Q*Q))+fabs(R),1.0/3.0)) ) - (a/3.0);
    } else {
      x1 = -( pow(sqrt((R*R)-(Q*Q*Q))+fabs(R),1.0/3.0) + (Q / pow(sqrt((R*R)-(Q*Q*Q))+fabs(R),1.0/3.0)) ) - (a/3.0);
    }
    x2 = x3 = 0.0 ;
  }
}
